struct hash;

struct tsdb
{
	char	*path;
	int	nrelations;
	struct relation
	{
		char	*name;
		int		nfields, loaded;
		struct field
		{
			char	*name;
			char	*type;
			int		iskey;
			struct hash	*hash;	// if iskey is set, map a key value to all the tuples[] matching it
		}	*fields;
		int		ntuples;
		int		atuples;
		char	***tuples;
	}	*relations;
};

struct tsdb	*load_tsdb(char	*path);
void	load_relation_data(struct tsdb	*p, struct relation	*r);
void	tsdb_reindex_relation(struct relation	*r);
int		tsdb_write_relation(struct tsdb	*p, struct relation	*r);

void read_relations(struct tsdb	*profile, char	*profile_path);
struct relation	*get_relation(struct tsdb	*profile, char	*name);
int				get_field(struct relation	*rel, char	*field, char	*type);
int	has_field(struct relation	*rel, char	*field, char	*type);
int	has_relation(struct tsdb	*profile, char	*relation);

char	**tsdb_lookup_relation_with_key(struct relation	*r, int	keyfield, char	*keyvalue);
int	tsdb_visit_relation_with_key(struct relation	*r, int	keyfield, char	*keyvalue, void	(*visitor)(char	**tuple));

int	tsdb_compatible(struct tsdb	*x, struct tsdb	*y);
